<?php

namespace BABO\Admin;

use RecursiveIteratorIterator;
use RecursiveDirectoryIterator;

/**
 * Admin side enqueues, page register, ajax handlers
 * 
 * @since 1.0.0 
 */
class Babo_Admin_Init
{

  public function __construct()
  {
    new Babo_Enqueues();
    new Babo_Pages();
    new Babo_Ajax_Handlers();

    add_action('babo_clear_backups', [$this, 'babo_remove_all_backups']); //daily recurring cron
  }

  public function babo_remove_all_backups()
  {

    $babokey = get_option('babo_backup_key');
    if (FALSE !== $babokey) {
      $bpath = WP_CONTENT_DIR . "/" . BABO_SLUG . "-" . esc_attr($babokey);

      $files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($bpath), RecursiveIteratorIterator::SELF_FIRST);

      foreach ($files as $file) {
        if (!$file->isDir() && FALSE !== stripos($file->getRealpath(), 'backupbolt-')) {
          @unlink($file->getRealpath());
        }
      }
    }
  }
}
