<?php

/**
 *
 * BackupBolt - Super simple WordPress backup plugin
 *
 * Plugin Name:       Backup Bolt
 * Plugin URI:        https://backupbolt.com
 * Description:       Super simple WordPress backup plugin
 * Version:           1.0.0
 * Author:            Go Web Smarty
 * Author URI:        https://gowebsmarty.com
 * License:           GNU General Public License v3.0
 * License URI:       http://www.gnu.org/licenses/gpl-3.0.html
 * Text Domain:       backup-bolt
 * Domain Path:       /languages
 *
 * @author      Go Web Smarty
 * @category    Plugin
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU General Public License v3.0
 *
 */

//exit on direct access
if (!defined('WPINC')) {
  die();
}

/**
 * Definitions
 */

define('BABO_VERSION', '1.0.0');
define('BABO_BASENAME', plugin_basename(__FILE__));
define('BABO_NAME', 'Backup Bolt');
define('BABO_PATH', trailingslashit(plugin_dir_path(__FILE__)));
define('BABO_URL', trailingslashit(plugin_dir_url(__FILE__)));
define('BABO_SLUG', 'backup-bolt');
define('BABO_TX',  'backup-bolt'); //textdomain

/**
 * Autoloader
 */
require_once __DIR__ . '/vendor/autoload.php';

/**
 * Activator & De-activator
 * 
 * @since 1.0.0
 */

use \BABO\Babo_Activator;
use \BABO\Babo_Deactivator;

function babo_activate()
{
  new Babo_Activator();
}

function babo_deactivate()
{
  new Babo_Deactivator();
}

register_activation_hook(__FILE__, 'babo_activate');
register_deactivation_hook(__FILE__, 'babo_deactivate');

/**
 * Core File
 */
require_once BABO_PATH . 'inc/main.php';
